require 'rest-client'

require File.dirname(__FILE__) + '/shilpa20/authentication_service'
require File.dirname(__FILE__) + '/shilpa20/user_service'
require File.dirname(__FILE__) + '/shilpa20/widget_service'
require File.dirname(__FILE__) + '/shilpa20/user_widget_service'
require File.dirname(__FILE__) + '/domain/application_config'

class Shilpa20

    def self.set_config(client_id, client_secret)
   #ApplicationConfig.set_config("277ef29692f9a70d511415dc60592daf4cf2c6f6552d3e1b769924b2f2e2e6fe", "d6106f26e8ff5b749a606a1fba557f44eb3dca8f48596847770beb9b643ea352")
       ApplicationConfig.set_config(client_id, client_secret)
    end
   
   
    #Create authentication token
    def self.create_authentication_token(auth_data)
       return AuthenticationService.create_authentication(auth_data) 
    end

    #Refresh authentication token
    def self.refresh_authentication_token(auth_data, bearer_token)
        return AuthenticationService.refresh_authentication_token(auth_data, bearer_token)
    end

    #Revoke authentication token
    def self.revoke_authentication_token(auth_data, bearer_token)
        return AuthenticationService.revoke_authentication_token(auth_data, bearer_token)
    end
    

    #Create user
    def self.create_user(user_data)
        return UserService.create_user(user_data) 
    end

     #Update user
     def self.update_user(user_data, bearer_token)
        return UserService.update_user(user_data, bearer_token) 
    end

    #Check email
    def self.check_email(user_data) 
        return UserService.check_email(user_data) 
    end

     #Reset password
     def self.reset_password(user_data) 
        return UserService.reset_password(user_data) 
    end

     #Change password
     def self.change_password(user_data, bearer_token)
        return UserService.change_password(user_data, bearer_token) 
    end

     #Show logged in user
      def self.show_logged_in_user(bearer_token)
        return UserService.show_logged_in_user(bearer_token) 
    end

    #Show user id
    def self.show_user_id(user_id, bearer_token)
        return UserService.show_user_id(user_id, bearer_token) 
    end

    #Get private widgets  
    def self.get_private_widgets(bearer_token)
        return UserWidgetService.get_private_widgets(bearer_token) 
    end

    #Get private widgets with search term
    def self.get_private_widgets_with_search_term(search_term, bearer_token)
        return UserWidgetService.get_private_widgets_with_search_term(search_term, bearer_token) 
    end

    #Get widgets by user id
    def self.get_widgets_by_user_id(user_id, bearer_token)
        return UserWidgetService.get_widgets_by_user_id(user_id, bearer_token)
    end

    #Get widgets by user id with search term
    def self.get_widgets_by_user_id_with_search_term(user_id, search_term, bearer_token)
        return UserWidgetService.get_widgets_by_user_id_with_search_term(user_id, search_term, bearer_token)
    end
    
    #Create widget
    def self.create_widget(widget_data, bearer_token)
        return WidgetService.create_widget(widget_data, bearer_token)
    end

     #Update widget
     def self.update_widget(widget_data, widget_id, bearer_token)
        return WidgetService.update_widget(widget_data, widget_id, bearer_token)
    end

     #Destroy widget
     def self.destroy_widget(widget_id, bearer_token)
        return WidgetService.destroy_widget(widget_id, bearer_token)
    end

     #Get private widgets
     def self.get_private_widgets(bearer_token)
        return WidgetService.get_private_widgets(bearer_token)
    end
    
    #Get public widgets
    def self.get_public_widgets(bearer_token)
        return WidgetService.get_public_widgets(bearer_token)
    end
    
    #Get public widgets with serach term
    def self.get_public_widgets_with_search_term(search_term, bearer_token)
        return WidgetService.get_public_widgets_with_search_term(search_term, bearer_token)
    end

    #Remove after tesing
    def self.get_access_token
        return ApplicationConfig.get_access_token
    end
    
end


#puts " Inside shilpa 20"
#Shilpa20.set_config("277ef29692f9a70d511415dc60592daf4cf2c6f6552d3e1b769924b2f2e2e6fe", "d6106f26e8ff5b749a606a1fba557f44eb3dca8f48596847770beb9b643ea352")
#puts Shilpa20.get_public_widgets("Bearer 6f7e1303f85a3ecf1655a4f17e49a668798d56af0ec5209afe6d55e8c511e5c1")
#widget = Widget.new
#widget.name = "First Widget"
#widget.description = "Test Description"
#widget.kind ="visible"
#puts Shilpa20.create_widget(widget, "Bearer 66a21599c5c1c64ce13ae520c672af28777f586b3bbc01755685e9bb6d1214bd")
#puts Shilpa20.refresh_authentication_token(AuthenticationService.create_auth_data)
#Shilpa20.set_config("cid1","csecret1")
#Shilpa20.getConfig
#puts  "Hi"